<?php
/*
 * db_forms - form definition form
 *
 * By Darryl Ross 1999
 *
 * $Header 
 *
 * djr@cyber.com.au
 *
 */
# Get a list of the fields in the table
$res = $db->metadata("$table");

$new_form = $load_defs = $update_defs = false;
reset($HTTP_POST_VARS);
while ( is_array($HTTP_POST_VARS) && list($key, $val) = each($HTTP_POST_VARS))
{
  switch ($key)
  {
    case "new_def" :
      $new_form = true;
    break;

    case "edit_def" :
      $load_defs = true;
      $old_name = $forms;
    break;
   
  }
}

# Create an instance of an ooh form
$f = new form;

$f->add_element(array("type"=>"text","name"=>"def_name","size"=>"15","maxlength"=>"80"));

# Set up the required html fields (to define the form) for each field in the database table
$n = 0;
while (list($key, $value) = each($res)) 
{
  if (!is_array($value) || !isset($value["name"]))
    continue;
  if (ereg("Field.*",$res[$key]["name"]))
    continue;
  $f->add_element(array("type"=>"checkbox","name"=>"field_name","multiple"=>1));
  $names[] = $res[$key]["name"];
  $n++;
} 

if ($new_form)
  $f->add_element(array("type"=>"hidden","name"=>"new_def"));
else
{
  $f->add_element(array("type"=>"hidden","name"=>"old_name","value"=>$old_name));
  $f->add_element(array("type"=>"hidden","name"=>"edit_def"));
}
$f->add_element(array("type"=>"hidden","name"=>"table","value"=>$table));
$f->add_element(array("type"=>"hidden","name"=>"form_name","value"=>$form_name));
$f->add_element(array("type"=>"submit","name"=>"submit"));

# If it is an edit, then load the current values for the form definition
if ($load_defs)
{
  $db->autofree = false;
  if ($report)
    $db->query("SELECT * FROM form_reports_defs WHERE report_name = '$old_name'");
  else
    $db->query("SELECT * FROM form_defs WHERE form_name = '$old_name'");
  $i = 0;
  # Loop through the all fields in the table, and see which ones are in the form definition
  for ($j = 0; $j < $n; $j++)
  {
    $db->seek(0); 
    while ($db->next_record())
    {
      if (trim($db->f("field_name")) == $names[$j])
      {
        $field_name[$j] = $names[$j];
	break;
      }
    }
  }
  # Tell ooh forms to use these values
  $def_name = $old_name;
  $f->load_defaults();
} 

if ($report)
  $f->start("","","forms_edit_report_defs.php3");
else
  $f->start("","","forms_edit_defs.php3");

echo "<h3>Select the fields from table $table for "; 
if ($report) 
  echo "report for form $form_name: ";
else 
echo " form: "; 
$f->show_element("def_name");
echo "</h3>\n";

for ($i = 0; $i < $n; $i++)
{
  $f->show_element("field_name", $names[$i]);
  echo "$names[$i]<br>\n";
} 

$f->show_element("submit","submit");

$f->finish(); 

?>

