<?php
/*
 * db_forms - form definition form
 *
 * By Darryl Ross 1999
 *
 * $Header 
 *
 * djr@cyber.com.au
 *
 */
include("prepend.php3");
# My extension of of_select, so that you can have an array of selects.
require("of_select_array.inc");

# page_open(array("sess" => "Cyber_Session", "auth" => "Cyber_Auth", "perm" => "Cyber_Perm"));
 $db =  new DB_Cyber;

?>
<html>
  <body>
    <h3>Report definition for <?php echo "$def_name ($form_name form)" ?></h3>
<?php

$report_types = array("html","download");

$new_form = $load_defs = $update_defs = false;
while ( is_array($HTTP_POST_VARS) && list($key, $val) = each($HTTP_POST_VARS))
{
  switch ($key)
  {
    case "new_def" :
      $new_form = true;
    break;

    case "edit_def" :
      $load_defs = true;
    break;
   
    case "submit_def" :
      $update_defs = true;
    break;
  }
}

# Create an instance of an ooh form
$f = new form;

# Set up the required html fields (to define the form) for each field in the database table
$bool[] = array("label"=>"yes","value"=>"1");
$bool[] = array("label"=>"no","value"=>"0");

  $f->add_element(array("type"=>"select","name"=>"report_type","options"=>$report_types, "value"=>"html"));
  $f->add_element(array("type"=>"text","name"=>"delimiter","size"=>"10","maxlength"=>"80", "value"=>","));
  $f->add_element(array("type"=>"text","name"=>"report_width","size"=>"10","maxlength"=>"80", "value"=>"100"));
  $f->add_element(array("type"=>"text","name"=>"delimiter","size"=>"10","maxlength"=>"80", "value"=>","));
  $f->add_element(array("type"=>"select","name"=>"download_field_names","options"=>$bool,"value"=>"0"));
$myselect = array("text","number","money","date");
for ($i = 0; $i < count($field_name); $i++)
{
  $f->add_element(array("type"=>"text","name"=>"label","multiple"=>1,"size"=>"15","maxlength"=>"80"));
  $f->add_element(array("type"=>"text","name"=>"col","multiple"=>1,"size"=>"5","maxlength"=>"10"));
  $f->add_element(array("type"=>"select_array","name"=>"format_type","options"=>$myselect,"value"=>"text"));
} 

$f->add_element(array("type"=>"text","name"=>"field_name","multiple"=>1,"value"=>$field_name));
if ($new_form)
  $f->add_element(array("type"=>"hidden","name"=>"new_def"));
  
$f->add_element(array("type"=>"hidden","name"=>"def_name","value"=>$def_name));
$f->add_element(array("type"=>"hidden","name"=>"old_name","value"=>$old_name));
$f->add_element(array("type"=>"hidden","name"=>"form_name","value"=>$form_name));
$f->add_element(array("type"=>"submit","name"=>"submit_def"));

# If it is an edit, then load the current values for the report definition
if ($load_defs)
{
  $db->autofree = false;
  $db->query("SELECT * FROM form_reports_defs WHERE report_name = '$old_name'");
  $i = 0;
  # Loop through the all fields in the table, and see which ones are in the form definition
  for ($j = 0; $j < count($field_name); $j++)
  {
    $db->seek(0); $flag = false;
    while ($db->next_record())
    {
      if (trim($db->f("field_name")) == $field_name[$j])
      {
        $flag = true;
	break;
      }
    }
    if ($flag)
    {
      $label[$j] = trim($db->f("label")); $col[$j] = $db->f("table_col"); $format_type[$j] = trim($db->f("format_type"));
    }
    else # If this field is not in the definition then load some defaults
    {
      $label[$j] = ""; $col[$j] = ""; $format_type = "text"; 
    }
  }
  # Tell ooh forms to use these values
  $db->query("SELECT * FROM form_reports WHERE report_name = '$old_name'");
  $db->next_record();
  $report_type = $db->f("report_type"); $delimiter = $db->f("delimiter"); 
  $report_width = $db->f("report_width"); $download_field_names = $db->f("download_field_names"); 

  $f->load_defaults();
} 
if ($update_defs)
{
  $flag = false;
  if (strlen($def_name) == 0)
  {
    $flag = true;
    echo "form name 0<br>";
  }
  else
  {
    # If the form definition exists then delete the old data, before inserting the update definition
    # NB this is buggy as a new form with the same name could merge in with an existing form
    if (!$new_form)
    {
      $db->query("DELETE FROM form_reports_defs WHERE report_name = '$old_name'");
      $db->query("UPDATE form_reports SET report_name = '$def_name', report_type = '$report_type', delimiter = '$delimiter' 
      	, report_width = '$report_width', download_field_names = '$download_field_names' WHERE report_name = '$old_name'");
    }
    else
      $db->query("INSERT INTO form_reports VALUES('$def_name','$form_name','$report_type','$delimiter','$download_field_names'
      	,'$report_width')");
    $n = count($field_name);
    if ($n > 0 )
    {
      for ($i = 0; $i < $n; $i++)
      {
        $query = "INSERT INTO form_reports_defs VALUES('$def_name','".$field_name[$i]."','".$label[$i]."','".$col[$i]."','".$format_type[$i]."')";
        $db->query($query);
        if ($db->affected_rows() == 0)
        {
          $flag = true;
       	  echo "insert failed<br>";
        }
      }
    }
  }

  if ($flag)
  {
    echo "error saving form definition<br>\n";
    $f->load_defaults();
  }
  else
  {
    echo "form definition saved!";
    exit;
  }
}
$f->freeze(array("field_name"));
$f->start();
echo "Report Type "; $f->show_element("report_type");
echo "Report Width (%) "; $f->show_element("report_width");
echo "Delimiter "; $f->show_element("delimiter");
echo "Download field names "; $f->show_element("download_field_names");
?>
<table>
  <tr>
    <th>Field</th><th>Label</th></th><th>col</th><th>width</th>
  </tr>
<?php
#for ($i = 0; $i < $res["num_fields"]; $i++)
for ($i = 0; $i < count($field_name); $i++)
{
  echo "<tr>\n";
  echo "<td>";
  $f->show_element("field_name");
  echo "</td>\n";
  echo "<td>";
  $f->show_element("label");
  echo "</td>\n";
  echo "<td>";
  $f->show_element("col");
  echo "</td>\n";
  echo "<td>";
  $f->show_element("format_type");
  echo "</td>\n";
  echo "</tr>\n";
} 

echo "</table>\n";
$f->show_element("submit_def","submit");

$f->finish(); 

?>

  </body>
</html>
