<?php
/*
 * db_forms - form definition form
 *
 * By Darryl Ross 1999
 *
 * $Header 
 *
 * djr@cyber.com.au
 *
 */
include("prepend.php3");

# My extension of of_select, so that you can have an array of selects.
require("of_select_array.inc");
# page_open(array("sess" => "Cyber_Session", "auth" => "Cyber_Auth", "perm" => "Cyber_Perm"));
 $db =  new DB_Cyber;

?>
<html>
  <body>
    <h3>Form definition for <?php echo "$def_name ($table table)" ?></h3>
<?php

$html_types = array("text","select","textarea","checkbox","radio","plain text","hidden","password");

$new_form = $load_defs = $update_defs = false;
while ( is_array($HTTP_POST_VARS) && list($key, $val) = each($HTTP_POST_VARS))
{
  switch ($key)
  {
    case "new_def" :
      $new_form = true;
    break;

    case "edit_def" :
      $load_defs = true;
    break;
   
    case "submit_def" :
      $update_defs = true;
    break;
  }
}

# Create an instance of an ooh form
$f = new form;

$bool[] = array("label"=>"yes","value"=>"1");
$bool[] = array("label"=>"no","value"=>"0");
$data_types = array("text","number","date/time");

# Set up the required html fields (to define the form) for each field in the database table
for ($i = 0; $i < count($field_name); $i++)
{
  $f->add_element(array("type"=>"text","name"=>"label","multiple"=>1,"size"=>"15","maxlength"=>"80"));
  $f->add_element(array("type"=>"text","name"=>"row","multiple"=>1,"size"=>"5","maxlength"=>"10"));
  $f->add_element(array("type"=>"text","name"=>"col","multiple"=>1,"size"=>"5","maxlength"=>"10"));
  $f->add_element(array("type"=>"select_array","name"=>"data_type","options"=>$data_types, "value"=>"text"));
  $f->add_element(array("type"=>"select_array","name"=>"html_type","options"=>$html_types, "value"=>"text"));
  $f->add_element(array("type"=>"text","name"=>"size","multiple"=>1,"size"=>"5","maxlength"=>"10"));
  $f->add_element(array("type"=>"text","name"=>"max_size","multiple"=>1,"size"=>"5","maxlength"=>"10"));
  $f->add_element(array("type"=>"text","name"=>"row_span","multiple"=>1,"size"=>"5","maxlength"=>"10","value"=>"1"));
  $f->add_element(array("type"=>"text","name"=>"col_span","multiple"=>1,"size"=>"5","maxlength"=>"10","value"=>"1"));
  $f->add_element(array("type"=>"select_array","name"=>"key_field","options"=>$bool,"value"=>"0"));
  $f->add_element(array("type"=>"select_array","name"=>"required","options"=>$bool,"value"=>"0"));
  $f->add_element(array("type"=>"text","name"=>"default","multiple"=>1,"size"=>"10","maxlength"=>"80"));
  $f->add_element(array("type"=>"text","name"=>"e_validate","multiple"=>1,"size"=>"15","maxlength"=>"80"));
  $f->add_element(array("type"=>"text","name"=>"s_validate","multiple"=>1,"size"=>"15","maxlength"=>"80"));
  $f->add_element(array("type"=>"text","name"=>"lookup","multiple"=>1,"size"=>"15","maxlength"=>"255"));
  $f->add_element(array("type"=>"text","name"=>"permissions","multiple"=>1,"size"=>"10","maxlength"=>"80"));
} 

$f->add_element(array("type"=>"text","name"=>"field_name","multiple"=>1,"value"=>$field_name));
if ($new_form)
  $f->add_element(array("type"=>"hidden","name"=>"new_def"));
  
$f->add_element(array("type"=>"hidden","name"=>"def_name","value"=>$def_name));
$f->add_element(array("type"=>"hidden","name"=>"old_name","value"=>$old_name));
$f->add_element(array("type"=>"hidden","name"=>"table","value"=>$table));
$f->add_element(array("type"=>"submit","name"=>"submit_def"));

# If it is an edit, then load the current values for the form definition
if ($load_defs)
{
  $db->autofree = false;
  $db->query("SELECT * FROM form_defs WHERE form_name = '$old_name'");
  $i = 0;
  # Loop through the all fields in the table, and see which ones are in the form definition
  for ($j = 0; $j < count($field_name); $j++)
  {
    $db->seek(0); $flag = false;
    while ($db->next_record())
    {
      if (trim($db->f("field_name")) == $field_name[$j])
      {
        $flag = true;
	break;
      }
    }
    if ($flag)
    {
      $label[$j] = trim($db->f("label")); $row[$j] = $db->f("table_row"); $col[$j] = $db->f("table_col");
      $data_type[$j] = trim($db->f("data_type")); $html_type[$j] = trim($db->f("html_type")); $size[$j] = $db->f("html_size");
      $max_size[$j] = $db->f("max_size"); $row_span[$j] = $db->f("rowspan"); $col_span[$j] = $db->f("colspan"); 
      $key_field[$j] = $db->f("key_field"); $required[$j] = $db->f("required"); $default[$j] = trim($db->f("default_value")); 
      $e_validate[$j] = trim($db->f("e_validate")); $s_validate[$j] = trim($db->f("s_validate"));$lookup[$j] = trim($db->f("lookup")); 
      $permissions[$j] = trim($db->f("permissions"));
    }
    else # If this field is not in the definition then load some defaults
    {
      $label[$j] = ""; $row[$j] = ""; $col[$j] = "";
      $data_type[$j] = "text"; $html_type[$j] = "text"; $size[$j] = "";
      $max_size[$j] = ""; $row_span[$j] = "1"; $col_span[$j] = "1"; 
      $key_field[$j] = "0"; $required[$j] = "0"; $default[$j] = ""; 
      $e_validate[$j] = ""; $s_validate[$j] = ""; $lookup[$j] = ""; $permissions[$j] = "";
    }
  }
  # Tell ooh forms to use these values
  $f->load_defaults();
} 
if ($update_defs)
{
  $flag = false;
  if (strlen($def_name) == 0)
  {
    $flag = true;
    echo "form name 0<br>";
  }
  else
  {
    # If the form definition exists then delete the old data, before inserting the update definition
    # NB this is buggy as a new form with the same name could merge in with an existing form
    if (!$new_form)
    {
      $db->query("DELETE FROM form_defs WHERE form_name = '$old_name'");
      $db->query("UPDATE forms SET form_name = '$def_name' WHERE form_name = '$old_name'");
    }
    else
      $db->query("INSERT INTO forms VALUES('$def_name','$table')");
    $n = count($field_name);
    if ($n > 0 )
    {
      for ($i = 0; $i < $n; $i++)
      {
        $query = "INSERT INTO form_defs VALUES('$def_name','".$field_name[$i]."','".$label[$i]."','".$row[$i];
        $query .= "','".$col[$i]."','".$data_type[$i]."','".$html_type[$i]."','".$size[$i]."','".$max_size[$i]."','".$row_span[$i];
        $query .= "','".$col_span[$i]."','".$key_field[$i]."','".$required[$i]."','".$default[$i]."','".$e_validate[$i];
        $query .= "','".$s_validate[$i]."','".$lookup[$i]."','".$permissions[$i]."')";
        $db->query($query);
        if ($db->affected_rows() == 0)
        {
          $flag = true;
       	  echo "insert failed<br>";
        }
      }
    }
  }

  if ($flag)
  {
    echo "error saving form definition<br>\n";
    $f->load_defaults();
  }
  else
  {
    echo "form definition saved!";
    exit;
  }
}
$f->freeze(array("field_name"));
$f->start();
?>
<table>
  <tr>
    <th>Field</th><th>Label</th><th>row</th><th>col</th><th>data type</th><th>html type</th><th>size</th><th>max size</th>
    <th>row span</th><th>col span</th><th>key</th><th>required</th><th>default</th><th>e_validate</th><th>s_validate</th>
    <th>lookup</th><th>permissions</th>
  </tr>
<?php
#for ($i = 0; $i < $res["num_fields"]; $i++)
for ($i = 0; $i < count($field_name); $i++)
{
  echo "<tr>\n";
  echo "<td>";
  $f->show_element("field_name");
  echo "</td>\n";
  echo "<td>";
  $f->show_element("label");
  echo "</td>\n";
  echo "<td>";
  $f->show_element("row");
  echo "</td>\n";
  echo "<td>";
  $f->show_element("col");
  echo "</td>\n";
  echo "<td>";
  $f->show_element("data_type");
  echo "</td>\n";
  echo "<td>";
  $f->show_element("html_type");
  echo "</td>\n";
  echo "<td>";
  $f->show_element("size");
  echo "</td>\n";
  echo "<td>";
  $f->show_element("max_size");
  echo "</td>\n";
  echo "<td>";
  $f->show_element("row_span");
  echo "</td>\n";
  echo "<td>";
  $f->show_element("col_span");
  echo "</td>\n";
  echo "<td>";
  $f->show_element("key_field");
  echo "</td>\n";
  echo "<td>";
  $f->show_element("required");
  echo "</td>\n";
  echo "<td>";
  $f->show_element("default");
  echo "</td>\n";
  echo "<td>";
  $f->show_element("e_validate");
  echo "</td>\n";
  echo "<td>";
  $f->show_element("s_validate");
  echo "</td>\n";
  echo "<td>";
  $f->show_element("lookup");
  echo "</td>\n";
  echo "<td>";
  $f->show_element("permissions");
  echo "</td>\n";
  echo "</tr>\n";
} 

echo "</table>\n";
$f->show_element("submit_def","submit");

$f->finish(); 

?>

  </body>
</html>
